
	section .bss

i	resd 1
j	resd 1

	section .data

osszeg	dd	0
tombunk	dd	1, 2, 3
hossz	dd	3

    ; a jegyzetben leirt parameterelhelyezes az igazi,
    ; de ha nem rekurziv a fuggveny, ez is mukodik

	section .text
	global main

main
	push dword [hossz]
	push dword tombunk
	call osszegzo
	add esp, 2*4

	mov eax, 1
	xor ebx, ebx
	int 0x80

osszegzo
	push ebp
	mov ebp, esp

; 0 ebp vissza tomb hossz

		; [ebp+8]  : int* tomb
			; (ezeket tobb utasitassal kell megoldani)
			; [[ebp+8]]   : elso int a tombben
			; [[ebp+8]+4] : masodik int a tombben
		; [ebp+12] : int hossz

	mov dword [i], 0

.kulso
	mov eax, [i]
	cmp eax, [ebp+12]
	jnb .kulso.vege

.kulso.ciklusmag
	mov eax, [i]
	mov [j], eax

.belso
	mov eax, [j]
	cmp eax, [ebp+12]
	jnb .belso.vege

.belso.ciklusmag
	mov esi, [ebp+8]	; esi = tomb
	mov eax, [i]		; eax = i
	mov eax, [esi+4*eax]	; eax = tomb[i]
	mov edx, [j]		; eax = j
	mov edx, [esi+4*edx]	; eax = tomb[j]

	cmp eax, edx
	jnle .hamis.ag		; tomb[i] <= tomb[j]
				; nem telj --> hamis ag

.igaz.ag
	mov esi, [ebp+8]	; tomb
	mov eax, [i]		; i
	mov eax, [esi+4*eax]	; tomb[i]
	add [osszeg], eax
	jmp .elagazas.vege

.hamis.ag
	mov esi, [ebp+8]	; tomb
	mov eax, [j]		; j
	mov eax, [esi+4*eax]	; tomb[j]
	add [osszeg], eax

.elagazas.vege
	inc dword [j]		; ++j
	jmp .belso

.belso.vege
	inc dword [i]		; ++i
	jmp .kulso

.kulso.vege
	mov eax, [osszeg]

	mov esp, ebp
	pop ebp
	ret

