
%macro fveleje 1
%1
	push ebp
	mov ebp, esp
%endm

%macro fvvege 0
	mov esp, ebp
	pop ebp
	ret
%endm

%macro fajl.megnyit 3
	mov eax, 5
	mov ebx, [ebp+12]
	mov ebx, [ebx+%1*4]
	mov ecx, %2
	int 0x80

	mov [%3], eax
%endm

%macro fajl.olvas 3
	mov eax, 3
	mov ebx, [%1]
	mov ecx, %2
	mov edx, %3
	int 0x80
%endm

%macro fajl.ir 3
	mov eax, 4
	mov ebx, [%1]
	mov ecx, %2
	mov edx, %3
	int 0x80
%endm

%macro fajl.leptet 3
	mov eax, 19
	mov ebx, [%1]
	mov ecx, %2
	mov edx, %3
	int 0x80
%endm

%macro kiir 2
	mov eax, 4
	mov ebx, 1
	mov ecx, %1
	mov edx, %2
	int 0x80
%endm

	section .bss

leiro		resd	1	; meg elegansabb, ha ezek a main lokalis valtozoi
pozicio		resd	1
fajlnevhossza	resd	1
szoveg		resb	256	; feltetelezzuk, ennel nem hosszabb
				; ha igen, akkor ezt pufferkent hasznalva
				; is meg lehet oldani a feladatot

	section .data

ok	db	"OK!", 0xA
nemok	db	"NEM", 0xA


	section .text
	global main

fveleje main
	mov eax, [ebp+12]
	push dword [eax+8]
	call konvertal
	mov [pozicio], eax	; masodik parameter konvertalasa

	fajl.megnyit 1, 0, leiro
	fajl.leptet leiro, [pozicio], 0

	mov edx, [ebp+12]
	mov edx, [edx+4]	; fajlnev eleje
	xor eax, eax

.szamlal
	cmp byte [edx], 0
	je .szamlalas.vege

	inc eax
	inc edx
	jmp .szamlal

.szamlalas.vege
	mov [fajlnevhossza], eax

	fajl.olvas leiro, szoveg, [fajlnevhossza]

	xor ecx, ecx
	mov edx, [ebp+12]
	mov edx, [edx+4]

.vizsgal
	cmp ecx, [fajlnevhossza]
	je .egyezik

	mov al, [szoveg+ecx]
	cmp al, [edx+ecx]
	jne .nemegyezik

	inc ecx
	jmp .vizsgal

.egyezik
	kiir ok, 4
	jmp .vege

.nemegyezik
	kiir nemok, 4

.vege
	mov eax, 1
	xor ebx, ebx
	int 0x80


fveleje konvertal
	mov eax, 2		; kamu :)
fvvege

